@echo off
cls
echo If not already done, please plugin your pushbox now for firmware update.
echo _
echo NOTE: Your pushbox configuration may be overwritten on this update. If you are not sure, press CTRL-C and confirm with Y(es). Please write/copy down your current configuration ("?;" command).
echo _
echo This batch file uses an automatic COM port detection. To override it call this batch i.e.: "thisfile.bat" COM3
echo _
echo If you are not sure, press CTRL-C and confirm with Yes to cancel this operation.
echo _
echo Press ENTER to continue
setlocal ENABLEDELAYEDEXPANSION
rem setlocal
set port=%1
if [%port%] NEQ [] (
  echo ---
  echo Batch calling parameter:
  echo %port%
  pause > nul
  call :flashtool
  goto :endkey
)

pause > nul

rem Automatic port detection
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino"') do (
  call :resetCOM "%%~J"
)
rem newer windows can also use timeout. Ping works also on older windows.
rem ping 127.0.0.1 -n 2 > nul
goto :endkey

:resetCOM <WMIC_output_line>
rem sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%

:flashtool
echo COM port=
echo %port%
flashtool -p%port% -check pushbox.hex
echo errorlevel: %errorlevel%
if errorlevel 1 goto :EOF

echo 1200 baud reset into bootloader for %port%
mode %port%: BAUD=1200 parity=N data=8 stop=1
timeout 3 > nul

REM first try
set success=0
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo bootloader"') do (
    call :setCOM "%%~J"
    set success=1
)
if %success%==1 goto :EOF

REM 2nd try
set success=0
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Micro bootloader"') do (
    call :setCOM "%%~J"
    set success=1
)
goto :EOF



:setCOM <WMIC_output_line>
rem sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo found bootloader at %port%
flashtool -p%port% -flash pushbox.hex
goto :EOF

:endkey
echo Press any key to exit.
pause > nul
